Getting Started with MaskedTextBox Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the MaskedTextBox module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.maskedtextbox.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-masked-text-box id="maskedtextbox"></smart-masked-text-box>

    Host container (id matches appendTo on Smart.MaskedTextBox):

    <div id="maskedtextboxContainer"></div>

  5. Initialize after the module loads: define a const maskedtextboxOptions object, then either bind with Smart('#maskedtextbox', ...) on the semantic tag or use new Smart.MaskedTextBox({ ...maskedtextboxOptions, appendTo: '#maskedtextboxContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.maskedtextbox.js';
    
    	const maskedtextboxOptions = { mask: "+1 (###) ### - ####" };
    
    	// Option A - semantic <smart-masked-text-box> with id="maskedtextbox"
    	Smart('#maskedtextbox', class {
    		get properties() {
    			return maskedtextboxOptions;
    		}
    	});
    
    	// Option B - host div id="maskedtextboxContainer"
    	// const maskedtextboxInstance = new Smart.MaskedTextBox({
    	// 	...maskedtextboxOptions,
    	// 	appendTo: '#maskedtextboxContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myMaskedTextBox = new Smart.MaskedTextBox('#maskedtextbox', maskedtextboxOptions);
    	// document.body.appendChild(myMaskedTextBox);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.MaskedTextBox('#maskedtextbox', maskedtextboxOptions) with appendChild, and document.createElement('smart-masked-text-box') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.MaskedTextBox({ ...options, appendTo: '#...' }); new Smart.MaskedTextBox('#maskedtextbox', maskedtextboxOptions) plus appendChild on the returned element; and document.createElement('smart-masked-text-box') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myMaskedTextBox = new Smart.MaskedTextBox('#maskedtextbox', maskedtextboxOptions)):

	const maskedtextboxOptions = { mask: "+1 (###) ### - ####" };
	const myMaskedTextBox = new Smart.MaskedTextBox('#maskedtextbox', maskedtextboxOptions);
	document.body.appendChild(myMaskedTextBox);
	

Create with document.createElement('smart-masked-text-box'), assign properties (same as any custom element), then append:

	const maskedtextboxOptions = { mask: "+1 (###) ### - ####" };
	const maskedtextbox = document.createElement('smart-masked-text-box');
	Object.assign(maskedtextbox, maskedtextboxOptions);
	document.body.appendChild(maskedtextbox);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.maskedtextbox.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const maskedtextboxOptions = { mask: "+1 (###) ### - ####" };
		const maskedtextbox = new Smart.MaskedTextBox({
			...maskedtextboxOptions,
			appendTo: '#maskedtextboxContainer'
		});
	}
	

Demo

Appearance

Smart.MaskedTextBox uses promptChar property to point the available user input positions. These position are defined by the mask property.

Mask characters are:

  • 0 - Accepts any single digit between 0 and 9.
  • 9 - Accepts digit or space.
  • # - Digit or space, optional. If this position is blank in the mask, it will be rendered as a space
  • L - Letter, required.
  • ? - Letter, optional
  • & - Character, required
  • C - Character, optional
  • A - Alphanumeric, required
  • a - Alphanumeric, optional
 <smart-masked-text-box mask="(###)###-####" prompt-char="*"></smart-masked-text-box>

Demo

The Masked Text Box could be filled on initialization via the value property

 <smart-masked-text-box value="123"></smart-masked-text-box>

Demo

hidePromptOnLeave property is responsible all prompt characters to be hidden when the element loses it's focus. If the element is focused, characters are rendered again in the input-s field. By default prompt characters are rendered

 <smart-masked-text-box hide-prompt-on-leave></smart-masked-text-box>

Demo

Behavior

If selectAllOnFocus is true the whole test is selected when the element is focused

 <smart-masked-text-box select-all-on-focus></smart-masked-text-box>

Demo

Smart.MaskedTextBox offers few different types of value formatting. The property responsible to this is textMaskFormat. It can be:

  • excludePromptAndLiterals - all prompt characters and literals are removed from the value
  • includePrompt - all literals characters are removed from the value
  • includeLiterals - all prompt characters are removed from the value
  • includePromptAndLiterals - the value is equal to the visualized input string.
<smart-masked-text-box text-mask-format="excludePromptAndLiterals"></smart-masked-text-box>

Demo

Similar to textMaskFormat is Smart.MaskedTextBox's cutCopyMaskFormat property. It's used to set the value in the clipboard after "cut" and "copy" operations.

 <smart-masked-text-box cut-copy-mask-format="excludePromptAndLiterals"></smart-masked-text-box>

Demo

Append to the DOM:

const container = document.getElementById('maskedtextbox-container');
container.appendChild(maskedtextbox);
	

Remove from the DOM:

maskedtextbox.remove();
	

Set a property:

maskedtextbox.disabled = true;
maskedtextbox.theme = 'dark';
	

Get a property value:

const isDisabled = maskedtextbox.disabled;
const currentTheme = maskedtextbox.theme;
	

Invoke a method:

maskedtextbox.refresh();
maskedtextbox.focus();
	

Add event listener:

maskedtextbox.addEventListener('change', (event) => {
    console.log('change triggered:', event.detail.oldValue);
});
	

Remove event listener:

const handleMaskedTextBoxEvent = (event) => {
    console.log('change triggered:', event.detail.oldValue);
};

maskedtextbox.addEventListener('change', handleMaskedTextBoxEvent);
maskedtextbox.removeEventListener('change', handleMaskedTextBoxEvent);
	

Accessibility

The MaskedTextBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React MaskedTextBox Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/maskedtextbox/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { MaskedTextBox } from 'smart-webcomponents-react/maskedtextbox';

function App() {
    // componentDidMount equivalent - not used in this example
    // React.useEffect(() => {
    //     // Put side effects here if needed
    // }, []);

    return (
        <div>
            <MaskedTextBox label="Phone number" hint="" value="" mask="+1 (###) ### - ####"></MaskedTextBox>
        </div>
    );
}

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { MaskedTextBox, MaskedTextBoxProps } from 'smart-webcomponents-react/maskedtextbox';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The MaskedTextBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular MaskedTextBox - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/maskedtextbox/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import MaskedTextBoxModule from smart-webcomponents-angular/maskedtextbox: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { MaskedTextBoxModule } from 'smart-webcomponents-angular/maskedtextbox';

4 Root component (standalone)

Add MaskedTextBoxModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { MaskedTextBoxComponent } from 'smart-webcomponents-angular/maskedtextbox';

import { MaskedTextBoxModule } from 'smart-webcomponents-angular/maskedtextbox';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ MaskedTextBoxModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('maskedtextbox', { read: MaskedTextBoxComponent, static: false }) maskedtextbox!: MaskedTextBoxComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-masked-text-box as needed:

 <smart-masked-text-box #maskedtextbox [label]="'Phone number'" [hint]="''" [value]="''" [mask]="'+1 (###) ### - ####'">
</smart-masked-text-box>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put MaskedTextBoxModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put MaskedTextBoxModule from smart-webcomponents-angular/maskedtextbox on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { MaskedTextBoxModule } from 'smart-webcomponents-angular/maskedtextbox';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, MaskedTextBoxModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The MaskedTextBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.